<?php
/**
 * Plugin Name: eQuate POS for WooCommerce
 * Description: Allows eQuate POS to connect to WooCommerce
 * Version: 1.0.0
 * WC tested up to: 4.9
 * Tested up to: 5.6
 * WC requires at least: 3.9
 * Author: eQuate POS Inc.
 * Author URI: https://equatepos.com/
*/

//
// products 
//
add_filter('woocommerce_rest_product_object_query', function(array $args, \WP_REST_Request $request) {
    $modified_after = $request->get_param('modified_after');
    if (!$modified_after) {
        return $args;
    }
    $args['date_query'][0]['column'] = 'post_modified';
    $args['date_query'][0]['after']  = $modified_after;

    return $args;

}, 10, 2);
//
// orders
//
add_filter('woocommerce_rest_orders_prepare_object_query', function(array $args, \WP_REST_Request $request) {
    $modified_after = $request->get_param('modified_after');

    if (!$modified_after) {
        return $args;
    }

    $args['date_query'][0]['column'] = 'post_modified';
    $args['date_query'][0]['after']  = $modified_after;

    return $args;

}, 10, 2);
//
// customers
//
function add_modified_after_filter_to_rest_api( $prepared_args, $request )
{
    if ($request->get_param('modified_after')) {
        $prepared_args['meta_query'] = array(
            array(
                'key'     => 'last_update',
                'value'   => (int) strtotime($request->get_param('modified_after')),
                'compare' => '>='
            ),
        );
    }
    
    return $prepared_args;
}
add_filter('woocommerce_rest_customer_query', 'add_modified_after_filter_to_rest_api', 10, 2);
//.
// allow only id to be called for products
//
function my_woocommerce_rest_prepare_product_object( $response, $object, $request ) 
{
   $data = $response->get_data();
   $newdata = [];
   if ($request['fields'] != null) {
      foreach ( explode ( ",", $request['fields'] ) as $field ) {
         $newdata[$field] = $data[$field];
      }
      $response->set_data( $newdata );
   }
   return $response;
}
add_filter( 'woocommerce_rest_prepare_product_object', 'my_woocommerce_rest_prepare_product_object', 10, 3 );
